package com.phlx.anchorcollect.db.gen;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteDatabase.CursorFactory;
import android.util.Log;

import org.greenrobot.greendao.AbstractDaoMaster;
import org.greenrobot.greendao.database.StandardDatabase;
import org.greenrobot.greendao.database.Database;
import org.greenrobot.greendao.database.DatabaseOpenHelper;
import org.greenrobot.greendao.identityscope.IdentityScopeType;


// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/**
 * Master of DAO (schema version 1): knows all DAOs.
 */
public class DaoMaster extends AbstractDaoMaster {
    public static final int SCHEMA_VERSION = 1;

    /** Creates underlying database table using DAOs. */
    public static void createAllTables(Database db, boolean ifNotExists) {
        AncestryinfoEntityDao.createTable(db, ifNotExists);
        BreedingRecordDetailEntityDao.createTable(db, ifNotExists);
        BreedingRecordEntityDao.createTable(db, ifNotExists);
        CardEntityDao.createTable(db, ifNotExists);
        CattleResumeEntityDao.createTable(db, ifNotExists);
        DictEntityDao.createTable(db, ifNotExists);
        GenTableDao.createTable(db, ifNotExists);
        GenTableColumnDao.createTable(db, ifNotExists);
        ImmuneEntityDao.createTable(db, ifNotExists);
        MedicalEntityDao.createTable(db, ifNotExists);
        PerformanceEntityDao.createTable(db, ifNotExists);
        UserRoleEntityDao.createTable(db, ifNotExists);
        WeightingEntityDao.createTable(db, ifNotExists);
    }

    /** Drops underlying database table using DAOs. */
    public static void dropAllTables(Database db, boolean ifExists) {
        AncestryinfoEntityDao.dropTable(db, ifExists);
        BreedingRecordDetailEntityDao.dropTable(db, ifExists);
        BreedingRecordEntityDao.dropTable(db, ifExists);
        CardEntityDao.dropTable(db, ifExists);
        CattleResumeEntityDao.dropTable(db, ifExists);
        DictEntityDao.dropTable(db, ifExists);
        GenTableDao.dropTable(db, ifExists);
        GenTableColumnDao.dropTable(db, ifExists);
        ImmuneEntityDao.dropTable(db, ifExists);
        MedicalEntityDao.dropTable(db, ifExists);
        PerformanceEntityDao.dropTable(db, ifExists);
        UserRoleEntityDao.dropTable(db, ifExists);
        WeightingEntityDao.dropTable(db, ifExists);
    }

    /**
     * WARNING: Drops all table on Upgrade! Use only during development.
     * Convenience method using a {@link DevOpenHelper}.
     */
    public static DaoSession newDevSession(Context context, String name) {
        Database db = new DevOpenHelper(context, name).getWritableDb();
        DaoMaster daoMaster = new DaoMaster(db);
        return daoMaster.newSession();
    }

    public DaoMaster(SQLiteDatabase db) {
        this(new StandardDatabase(db));
    }

    public DaoMaster(Database db) {
        super(db, SCHEMA_VERSION);
        registerDaoClass(AncestryinfoEntityDao.class);
        registerDaoClass(BreedingRecordDetailEntityDao.class);
        registerDaoClass(BreedingRecordEntityDao.class);
        registerDaoClass(CardEntityDao.class);
        registerDaoClass(CattleResumeEntityDao.class);
        registerDaoClass(DictEntityDao.class);
        registerDaoClass(GenTableDao.class);
        registerDaoClass(GenTableColumnDao.class);
        registerDaoClass(ImmuneEntityDao.class);
        registerDaoClass(MedicalEntityDao.class);
        registerDaoClass(PerformanceEntityDao.class);
        registerDaoClass(UserRoleEntityDao.class);
        registerDaoClass(WeightingEntityDao.class);
    }

    public DaoSession newSession() {
        return new DaoSession(db, IdentityScopeType.Session, daoConfigMap);
    }

    public DaoSession newSession(IdentityScopeType type) {
        return new DaoSession(db, type, daoConfigMap);
    }

    /**
     * Calls {@link #createAllTables(Database, boolean)} in {@link #onCreate(Database)} -
     */
    public static abstract class OpenHelper extends DatabaseOpenHelper {
        public OpenHelper(Context context, String name) {
            super(context, name, SCHEMA_VERSION);
        }

        public OpenHelper(Context context, String name, CursorFactory factory) {
            super(context, name, factory, SCHEMA_VERSION);
        }

        @Override
        public void onCreate(Database db) {
            Log.i("greenDAO", "Creating tables for schema version " + SCHEMA_VERSION);
            createAllTables(db, false);
        }
    }

    /** WARNING: Drops all table on Upgrade! Use only during development. */
    public static class DevOpenHelper extends OpenHelper {
        public DevOpenHelper(Context context, String name) {
            super(context, name);
        }

        public DevOpenHelper(Context context, String name, CursorFactory factory) {
            super(context, name, factory);
        }

        @Override
        public void onUpgrade(Database db, int oldVersion, int newVersion) {
            Log.i("greenDAO", "Upgrading schema from version " + oldVersion + " to " + newVersion + " by dropping all tables");
            dropAllTables(db, true);
            onCreate(db);
        }
    }

}
