package com.phlx.anchorcollect.db.gen;

import android.database.Cursor;
import android.database.sqlite.SQLiteStatement;

import org.greenrobot.greendao.AbstractDao;
import org.greenrobot.greendao.Property;
import org.greenrobot.greendao.internal.DaoConfig;
import org.greenrobot.greendao.database.Database;
import org.greenrobot.greendao.database.DatabaseStatement;

import com.phlx.anchorcollect.entity.MedicalEntity;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/** 
 * DAO for table "MEDICAL_ENTITY".
*/
public class MedicalEntityDao extends AbstractDao<MedicalEntity, Long> {

    public static final String TABLENAME = "MEDICAL_ENTITY";

    /**
     * Properties of entity MedicalEntity.<br/>
     * Can be used for QueryBuilder and for referencing column names.
     */
    public static class Properties {
        public final static Property Id = new Property(0, Long.class, "id", true, "_id");
        public final static Property Unid = new Property(1, String.class, "unid", false, "UNID");
        public final static Property RegistrationNo = new Property(2, String.class, "registrationNo", false, "REGISTRATION_NO");
        public final static Property TreatDate = new Property(3, String.class, "treatDate", false, "TREAT_DATE");
        public final static Property TreatPersonnel = new Property(4, String.class, "treatPersonnel", false, "TREAT_PERSONNEL");
        public final static Property CauseOf = new Property(5, String.class, "causeOf", false, "CAUSE_OF");
        public final static Property BatchNo = new Property(6, String.class, "batchNo", false, "BATCH_NO");
        public final static Property DrugName = new Property(7, String.class, "drugName", false, "DRUG_NAME");
        public final static Property ProductName = new Property(8, String.class, "productName", false, "PRODUCT_NAME");
        public final static Property Specifications = new Property(9, String.class, "specifications", false, "SPECIFICATIONS");
        public final static Property RemainingNumber = new Property(10, String.class, "remainingNumber", false, "REMAINING_NUMBER");
        public final static Property Number = new Property(11, String.class, "number", false, "NUMBER");
        public final static Property DrugMethods = new Property(12, String.class, "drugMethods", false, "DRUG_METHODS");
        public final static Property HoofDisease = new Property(13, String.class, "hoofDisease", false, "HOOF_DISEASE");
        public final static Property Insecticide = new Property(14, String.class, "insecticide", false, "INSECTICIDE");
        public final static Property Results = new Property(15, String.class, "results", false, "RESULTS");
        public final static Property UpdateId = new Property(16, String.class, "updateId", false, "UPDATE_ID");
        public final static Property CreateBy = new Property(17, String.class, "createBy", false, "CREATE_BY");
        public final static Property CreateTime = new Property(18, String.class, "createTime", false, "CREATE_TIME");
        public final static Property UpdateBy = new Property(19, String.class, "updateBy", false, "UPDATE_BY");
        public final static Property UpdateTime = new Property(20, String.class, "updateTime", false, "UPDATE_TIME");
        public final static Property Permissions = new Property(21, String.class, "permissions", false, "PERMISSIONS");
        public final static Property InputTime = new Property(22, String.class, "inputTime", false, "INPUT_TIME");
    }


    public MedicalEntityDao(DaoConfig config) {
        super(config);
    }
    
    public MedicalEntityDao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
    }

    /** Creates the underlying database table. */
    public static void createTable(Database db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "\"MEDICAL_ENTITY\" (" + //
                "\"_id\" INTEGER PRIMARY KEY ," + // 0: id
                "\"UNID\" TEXT," + // 1: unid
                "\"REGISTRATION_NO\" TEXT," + // 2: registrationNo
                "\"TREAT_DATE\" TEXT," + // 3: treatDate
                "\"TREAT_PERSONNEL\" TEXT," + // 4: treatPersonnel
                "\"CAUSE_OF\" TEXT," + // 5: causeOf
                "\"BATCH_NO\" TEXT," + // 6: batchNo
                "\"DRUG_NAME\" TEXT," + // 7: drugName
                "\"PRODUCT_NAME\" TEXT," + // 8: productName
                "\"SPECIFICATIONS\" TEXT," + // 9: specifications
                "\"REMAINING_NUMBER\" TEXT," + // 10: remainingNumber
                "\"NUMBER\" TEXT," + // 11: number
                "\"DRUG_METHODS\" TEXT," + // 12: drugMethods
                "\"HOOF_DISEASE\" TEXT," + // 13: hoofDisease
                "\"INSECTICIDE\" TEXT," + // 14: insecticide
                "\"RESULTS\" TEXT," + // 15: results
                "\"UPDATE_ID\" TEXT," + // 16: updateId
                "\"CREATE_BY\" TEXT," + // 17: createBy
                "\"CREATE_TIME\" TEXT," + // 18: createTime
                "\"UPDATE_BY\" TEXT," + // 19: updateBy
                "\"UPDATE_TIME\" TEXT," + // 20: updateTime
                "\"PERMISSIONS\" TEXT," + // 21: permissions
                "\"INPUT_TIME\" TEXT);"); // 22: inputTime
    }

    /** Drops the underlying database table. */
    public static void dropTable(Database db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "\"MEDICAL_ENTITY\"";
        db.execSQL(sql);
    }

    @Override
    protected final void bindValues(DatabaseStatement stmt, MedicalEntity entity) {
        stmt.clearBindings();
 
        Long id = entity.getId();
        if (id != null) {
            stmt.bindLong(1, id);
        }
 
        String unid = entity.getUnid();
        if (unid != null) {
            stmt.bindString(2, unid);
        }
 
        String registrationNo = entity.getRegistrationNo();
        if (registrationNo != null) {
            stmt.bindString(3, registrationNo);
        }
 
        String treatDate = entity.getTreatDate();
        if (treatDate != null) {
            stmt.bindString(4, treatDate);
        }
 
        String treatPersonnel = entity.getTreatPersonnel();
        if (treatPersonnel != null) {
            stmt.bindString(5, treatPersonnel);
        }
 
        String causeOf = entity.getCauseOf();
        if (causeOf != null) {
            stmt.bindString(6, causeOf);
        }
 
        String batchNo = entity.getBatchNo();
        if (batchNo != null) {
            stmt.bindString(7, batchNo);
        }
 
        String drugName = entity.getDrugName();
        if (drugName != null) {
            stmt.bindString(8, drugName);
        }
 
        String productName = entity.getProductName();
        if (productName != null) {
            stmt.bindString(9, productName);
        }
 
        String specifications = entity.getSpecifications();
        if (specifications != null) {
            stmt.bindString(10, specifications);
        }
 
        String remainingNumber = entity.getRemainingNumber();
        if (remainingNumber != null) {
            stmt.bindString(11, remainingNumber);
        }
 
        String number = entity.getNumber();
        if (number != null) {
            stmt.bindString(12, number);
        }
 
        String drugMethods = entity.getDrugMethods();
        if (drugMethods != null) {
            stmt.bindString(13, drugMethods);
        }
 
        String hoofDisease = entity.getHoofDisease();
        if (hoofDisease != null) {
            stmt.bindString(14, hoofDisease);
        }
 
        String insecticide = entity.getInsecticide();
        if (insecticide != null) {
            stmt.bindString(15, insecticide);
        }
 
        String results = entity.getResults();
        if (results != null) {
            stmt.bindString(16, results);
        }
 
        String updateId = entity.getUpdateId();
        if (updateId != null) {
            stmt.bindString(17, updateId);
        }
 
        String createBy = entity.getCreateBy();
        if (createBy != null) {
            stmt.bindString(18, createBy);
        }
 
        String createTime = entity.getCreateTime();
        if (createTime != null) {
            stmt.bindString(19, createTime);
        }
 
        String updateBy = entity.getUpdateBy();
        if (updateBy != null) {
            stmt.bindString(20, updateBy);
        }
 
        String updateTime = entity.getUpdateTime();
        if (updateTime != null) {
            stmt.bindString(21, updateTime);
        }
 
        String permissions = entity.getPermissions();
        if (permissions != null) {
            stmt.bindString(22, permissions);
        }
 
        String inputTime = entity.getInputTime();
        if (inputTime != null) {
            stmt.bindString(23, inputTime);
        }
    }

    @Override
    protected final void bindValues(SQLiteStatement stmt, MedicalEntity entity) {
        stmt.clearBindings();
 
        Long id = entity.getId();
        if (id != null) {
            stmt.bindLong(1, id);
        }
 
        String unid = entity.getUnid();
        if (unid != null) {
            stmt.bindString(2, unid);
        }
 
        String registrationNo = entity.getRegistrationNo();
        if (registrationNo != null) {
            stmt.bindString(3, registrationNo);
        }
 
        String treatDate = entity.getTreatDate();
        if (treatDate != null) {
            stmt.bindString(4, treatDate);
        }
 
        String treatPersonnel = entity.getTreatPersonnel();
        if (treatPersonnel != null) {
            stmt.bindString(5, treatPersonnel);
        }
 
        String causeOf = entity.getCauseOf();
        if (causeOf != null) {
            stmt.bindString(6, causeOf);
        }
 
        String batchNo = entity.getBatchNo();
        if (batchNo != null) {
            stmt.bindString(7, batchNo);
        }
 
        String drugName = entity.getDrugName();
        if (drugName != null) {
            stmt.bindString(8, drugName);
        }
 
        String productName = entity.getProductName();
        if (productName != null) {
            stmt.bindString(9, productName);
        }
 
        String specifications = entity.getSpecifications();
        if (specifications != null) {
            stmt.bindString(10, specifications);
        }
 
        String remainingNumber = entity.getRemainingNumber();
        if (remainingNumber != null) {
            stmt.bindString(11, remainingNumber);
        }
 
        String number = entity.getNumber();
        if (number != null) {
            stmt.bindString(12, number);
        }
 
        String drugMethods = entity.getDrugMethods();
        if (drugMethods != null) {
            stmt.bindString(13, drugMethods);
        }
 
        String hoofDisease = entity.getHoofDisease();
        if (hoofDisease != null) {
            stmt.bindString(14, hoofDisease);
        }
 
        String insecticide = entity.getInsecticide();
        if (insecticide != null) {
            stmt.bindString(15, insecticide);
        }
 
        String results = entity.getResults();
        if (results != null) {
            stmt.bindString(16, results);
        }
 
        String updateId = entity.getUpdateId();
        if (updateId != null) {
            stmt.bindString(17, updateId);
        }
 
        String createBy = entity.getCreateBy();
        if (createBy != null) {
            stmt.bindString(18, createBy);
        }
 
        String createTime = entity.getCreateTime();
        if (createTime != null) {
            stmt.bindString(19, createTime);
        }
 
        String updateBy = entity.getUpdateBy();
        if (updateBy != null) {
            stmt.bindString(20, updateBy);
        }
 
        String updateTime = entity.getUpdateTime();
        if (updateTime != null) {
            stmt.bindString(21, updateTime);
        }
 
        String permissions = entity.getPermissions();
        if (permissions != null) {
            stmt.bindString(22, permissions);
        }
 
        String inputTime = entity.getInputTime();
        if (inputTime != null) {
            stmt.bindString(23, inputTime);
        }
    }

    @Override
    public Long readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0);
    }    

    @Override
    public MedicalEntity readEntity(Cursor cursor, int offset) {
        MedicalEntity entity = new MedicalEntity( //
            cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0), // id
            cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1), // unid
            cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2), // registrationNo
            cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3), // treatDate
            cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4), // treatPersonnel
            cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5), // causeOf
            cursor.isNull(offset + 6) ? null : cursor.getString(offset + 6), // batchNo
            cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7), // drugName
            cursor.isNull(offset + 8) ? null : cursor.getString(offset + 8), // productName
            cursor.isNull(offset + 9) ? null : cursor.getString(offset + 9), // specifications
            cursor.isNull(offset + 10) ? null : cursor.getString(offset + 10), // remainingNumber
            cursor.isNull(offset + 11) ? null : cursor.getString(offset + 11), // number
            cursor.isNull(offset + 12) ? null : cursor.getString(offset + 12), // drugMethods
            cursor.isNull(offset + 13) ? null : cursor.getString(offset + 13), // hoofDisease
            cursor.isNull(offset + 14) ? null : cursor.getString(offset + 14), // insecticide
            cursor.isNull(offset + 15) ? null : cursor.getString(offset + 15), // results
            cursor.isNull(offset + 16) ? null : cursor.getString(offset + 16), // updateId
            cursor.isNull(offset + 17) ? null : cursor.getString(offset + 17), // createBy
            cursor.isNull(offset + 18) ? null : cursor.getString(offset + 18), // createTime
            cursor.isNull(offset + 19) ? null : cursor.getString(offset + 19), // updateBy
            cursor.isNull(offset + 20) ? null : cursor.getString(offset + 20), // updateTime
            cursor.isNull(offset + 21) ? null : cursor.getString(offset + 21), // permissions
            cursor.isNull(offset + 22) ? null : cursor.getString(offset + 22) // inputTime
        );
        return entity;
    }
     
    @Override
    public void readEntity(Cursor cursor, MedicalEntity entity, int offset) {
        entity.setId(cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0));
        entity.setUnid(cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1));
        entity.setRegistrationNo(cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2));
        entity.setTreatDate(cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3));
        entity.setTreatPersonnel(cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4));
        entity.setCauseOf(cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5));
        entity.setBatchNo(cursor.isNull(offset + 6) ? null : cursor.getString(offset + 6));
        entity.setDrugName(cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7));
        entity.setProductName(cursor.isNull(offset + 8) ? null : cursor.getString(offset + 8));
        entity.setSpecifications(cursor.isNull(offset + 9) ? null : cursor.getString(offset + 9));
        entity.setRemainingNumber(cursor.isNull(offset + 10) ? null : cursor.getString(offset + 10));
        entity.setNumber(cursor.isNull(offset + 11) ? null : cursor.getString(offset + 11));
        entity.setDrugMethods(cursor.isNull(offset + 12) ? null : cursor.getString(offset + 12));
        entity.setHoofDisease(cursor.isNull(offset + 13) ? null : cursor.getString(offset + 13));
        entity.setInsecticide(cursor.isNull(offset + 14) ? null : cursor.getString(offset + 14));
        entity.setResults(cursor.isNull(offset + 15) ? null : cursor.getString(offset + 15));
        entity.setUpdateId(cursor.isNull(offset + 16) ? null : cursor.getString(offset + 16));
        entity.setCreateBy(cursor.isNull(offset + 17) ? null : cursor.getString(offset + 17));
        entity.setCreateTime(cursor.isNull(offset + 18) ? null : cursor.getString(offset + 18));
        entity.setUpdateBy(cursor.isNull(offset + 19) ? null : cursor.getString(offset + 19));
        entity.setUpdateTime(cursor.isNull(offset + 20) ? null : cursor.getString(offset + 20));
        entity.setPermissions(cursor.isNull(offset + 21) ? null : cursor.getString(offset + 21));
        entity.setInputTime(cursor.isNull(offset + 22) ? null : cursor.getString(offset + 22));
     }
    
    @Override
    protected final Long updateKeyAfterInsert(MedicalEntity entity, long rowId) {
        entity.setId(rowId);
        return rowId;
    }
    
    @Override
    public Long getKey(MedicalEntity entity) {
        if(entity != null) {
            return entity.getId();
        } else {
            return null;
        }
    }

    @Override
    public boolean hasKey(MedicalEntity entity) {
        return entity.getId() != null;
    }

    @Override
    protected final boolean isEntityUpdateable() {
        return true;
    }
    
}
