package com.phlx.anchorcollect.db.gen;

import android.database.Cursor;
import android.database.sqlite.SQLiteStatement;

import org.greenrobot.greendao.AbstractDao;
import org.greenrobot.greendao.Property;
import org.greenrobot.greendao.internal.DaoConfig;
import org.greenrobot.greendao.database.Database;
import org.greenrobot.greendao.database.DatabaseStatement;

import com.phlx.anchorcollect.entity.WeightingEntity;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/** 
 * DAO for table "WEIGHTING_ENTITY".
*/
public class WeightingEntityDao extends AbstractDao<WeightingEntity, String> {

    public static final String TABLENAME = "WEIGHTING_ENTITY";

    /**
     * Properties of entity WeightingEntity.<br/>
     * Can be used for QueryBuilder and for referencing column names.
     */
    public static class Properties {
        public final static Property Id = new Property(0, long.class, "id", false, "ID");
        public final static Property Unid = new Property(1, String.class, "unid", true, "UNID");
        public final static Property RegistrationNo = new Property(2, String.class, "RegistrationNo", false, "REGISTRATION_NO");
        public final static Property WeightName = new Property(3, String.class, "weightName", false, "WEIGHT_NAME");
        public final static Property Weight = new Property(4, String.class, "weight", false, "WEIGHT");
        public final static Property WeightingDate = new Property(5, String.class, "weightingDate", false, "WEIGHTING_DATE");
        public final static Property PrincipalName = new Property(6, String.class, "principalName", false, "PRINCIPAL_NAME");
        public final static Property PrincipalId = new Property(7, String.class, "principalId", false, "PRINCIPAL_ID");
        public final static Property WeightCount = new Property(8, String.class, "weightCount", false, "WEIGHT_COUNT");
        public final static Property CircleNo = new Property(9, String.class, "circleNo", false, "CIRCLE_NO");
    }


    public WeightingEntityDao(DaoConfig config) {
        super(config);
    }
    
    public WeightingEntityDao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
    }

    /** Creates the underlying database table. */
    public static void createTable(Database db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "\"WEIGHTING_ENTITY\" (" + //
                "\"ID\" INTEGER NOT NULL ," + // 0: id
                "\"UNID\" TEXT PRIMARY KEY NOT NULL ," + // 1: unid
                "\"REGISTRATION_NO\" TEXT," + // 2: RegistrationNo
                "\"WEIGHT_NAME\" TEXT," + // 3: weightName
                "\"WEIGHT\" TEXT," + // 4: weight
                "\"WEIGHTING_DATE\" TEXT," + // 5: weightingDate
                "\"PRINCIPAL_NAME\" TEXT," + // 6: principalName
                "\"PRINCIPAL_ID\" TEXT," + // 7: principalId
                "\"WEIGHT_COUNT\" TEXT," + // 8: weightCount
                "\"CIRCLE_NO\" TEXT);"); // 9: circleNo
    }

    /** Drops the underlying database table. */
    public static void dropTable(Database db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "\"WEIGHTING_ENTITY\"";
        db.execSQL(sql);
    }

    @Override
    protected final void bindValues(DatabaseStatement stmt, WeightingEntity entity) {
        stmt.clearBindings();
        stmt.bindLong(1, entity.getId());
 
        String unid = entity.getUnid();
        if (unid != null) {
            stmt.bindString(2, unid);
        }
 
        String RegistrationNo = entity.getRegistrationNo();
        if (RegistrationNo != null) {
            stmt.bindString(3, RegistrationNo);
        }
 
        String weightName = entity.getWeightName();
        if (weightName != null) {
            stmt.bindString(4, weightName);
        }
 
        String weight = entity.getWeight();
        if (weight != null) {
            stmt.bindString(5, weight);
        }
 
        String weightingDate = entity.getWeightingDate();
        if (weightingDate != null) {
            stmt.bindString(6, weightingDate);
        }
 
        String principalName = entity.getPrincipalName();
        if (principalName != null) {
            stmt.bindString(7, principalName);
        }
 
        String principalId = entity.getPrincipalId();
        if (principalId != null) {
            stmt.bindString(8, principalId);
        }
 
        String weightCount = entity.getWeightCount();
        if (weightCount != null) {
            stmt.bindString(9, weightCount);
        }
 
        String circleNo = entity.getCircleNo();
        if (circleNo != null) {
            stmt.bindString(10, circleNo);
        }
    }

    @Override
    protected final void bindValues(SQLiteStatement stmt, WeightingEntity entity) {
        stmt.clearBindings();
        stmt.bindLong(1, entity.getId());
 
        String unid = entity.getUnid();
        if (unid != null) {
            stmt.bindString(2, unid);
        }
 
        String RegistrationNo = entity.getRegistrationNo();
        if (RegistrationNo != null) {
            stmt.bindString(3, RegistrationNo);
        }
 
        String weightName = entity.getWeightName();
        if (weightName != null) {
            stmt.bindString(4, weightName);
        }
 
        String weight = entity.getWeight();
        if (weight != null) {
            stmt.bindString(5, weight);
        }
 
        String weightingDate = entity.getWeightingDate();
        if (weightingDate != null) {
            stmt.bindString(6, weightingDate);
        }
 
        String principalName = entity.getPrincipalName();
        if (principalName != null) {
            stmt.bindString(7, principalName);
        }
 
        String principalId = entity.getPrincipalId();
        if (principalId != null) {
            stmt.bindString(8, principalId);
        }
 
        String weightCount = entity.getWeightCount();
        if (weightCount != null) {
            stmt.bindString(9, weightCount);
        }
 
        String circleNo = entity.getCircleNo();
        if (circleNo != null) {
            stmt.bindString(10, circleNo);
        }
    }

    @Override
    public String readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1);
    }    

    @Override
    public WeightingEntity readEntity(Cursor cursor, int offset) {
        WeightingEntity entity = new WeightingEntity( //
            cursor.getLong(offset + 0), // id
            cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1), // unid
            cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2), // RegistrationNo
            cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3), // weightName
            cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4), // weight
            cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5), // weightingDate
            cursor.isNull(offset + 6) ? null : cursor.getString(offset + 6), // principalName
            cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7), // principalId
            cursor.isNull(offset + 8) ? null : cursor.getString(offset + 8), // weightCount
            cursor.isNull(offset + 9) ? null : cursor.getString(offset + 9) // circleNo
        );
        return entity;
    }
     
    @Override
    public void readEntity(Cursor cursor, WeightingEntity entity, int offset) {
        entity.setId(cursor.getLong(offset + 0));
        entity.setUnid(cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1));
        entity.setRegistrationNo(cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2));
        entity.setWeightName(cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3));
        entity.setWeight(cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4));
        entity.setWeightingDate(cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5));
        entity.setPrincipalName(cursor.isNull(offset + 6) ? null : cursor.getString(offset + 6));
        entity.setPrincipalId(cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7));
        entity.setWeightCount(cursor.isNull(offset + 8) ? null : cursor.getString(offset + 8));
        entity.setCircleNo(cursor.isNull(offset + 9) ? null : cursor.getString(offset + 9));
     }
    
    @Override
    protected final String updateKeyAfterInsert(WeightingEntity entity, long rowId) {
        return entity.getUnid();
    }
    
    @Override
    public String getKey(WeightingEntity entity) {
        if(entity != null) {
            return entity.getUnid();
        } else {
            return null;
        }
    }

    @Override
    public boolean hasKey(WeightingEntity entity) {
        return entity.getUnid() != null;
    }

    @Override
    protected final boolean isEntityUpdateable() {
        return true;
    }
    
}
