package com.phlx.anchorcollect.entity;

import android.os.Parcel;
import android.os.Parcelable;

import androidx.databinding.BaseObservable;

import org.greenrobot.greendao.annotation.Entity;
import org.greenrobot.greendao.annotation.Id;

import java.util.Date;
import org.greenrobot.greendao.annotation.Generated;

/**
 * 配种记子对象 zxgl_cattlemating_detaill
 *
 * @author phlx
 * @date 2022-01-10
 */
@Entity
public class BreedingRecordDetailEntity extends BaseObservable implements Parcelable {

    /**
     * unid
     */
    @Id(autoincrement = false)
    private String unid;

    /**
     * 主表ID
     */
    private String fUnid;

    /**
     * 配种方式;（本交，受精）
     */
    private String matingStyle;

    /**
     * 种畜耳标号
     */
    private String cattleresumeId;

    /**
     * 冻精批次号
     */
    private String frozenSemenBatch;

    /**
     * 配种日期
     */
    private String matingDate;

    /**
     * 是否返情
     */
    private String isReturn;

    /**
     * 返情日期
     */
    private String backLoveDate;

    /**
     * 预产日期
     */
    private String dueDate;

    /**
     * 配种成功
     */
    private String pregnancy;

    /**
     * 部门id
     */
    private String deptId;

    /** 是否上传 0未上传，1已上传 */
    private String uploadStatus;


    /** 搜索值 */
    private String searchValue;

    /** 创建者 */
    private String createBy;

    /** 创建时间 */
    private String createTime;

    /** 更新者 */
    private String updateBy;

    /** 更新时间 */
    private String updateTime;

    /** 备注 */
    private String remark;

    public BreedingRecordDetailEntity() {
    }

    protected BreedingRecordDetailEntity(Parcel in) {
        unid = in.readString();
        fUnid = in.readString();
        matingStyle = in.readString();
        cattleresumeId = in.readString();
        frozenSemenBatch = in.readString();
        matingDate = in.readString();
        isReturn = in.readString();
        backLoveDate = in.readString();
        dueDate = in.readString();
        pregnancy = in.readString();
        deptId = in.readString();
        uploadStatus = in.readString();
        searchValue = in.readString();
        createBy = in.readString();
        createTime = in.readString();
        updateBy = in.readString();
        updateTime = in.readString();
        remark = in.readString();
    }

    @Generated(hash = 2062840275)
    public BreedingRecordDetailEntity(String unid, String fUnid, String matingStyle, String cattleresumeId,
            String frozenSemenBatch, String matingDate, String isReturn, String backLoveDate, String dueDate,
            String pregnancy, String deptId, String uploadStatus, String searchValue, String createBy,
            String createTime, String updateBy, String updateTime, String remark) {
        this.unid = unid;
        this.fUnid = fUnid;
        this.matingStyle = matingStyle;
        this.cattleresumeId = cattleresumeId;
        this.frozenSemenBatch = frozenSemenBatch;
        this.matingDate = matingDate;
        this.isReturn = isReturn;
        this.backLoveDate = backLoveDate;
        this.dueDate = dueDate;
        this.pregnancy = pregnancy;
        this.deptId = deptId;
        this.uploadStatus = uploadStatus;
        this.searchValue = searchValue;
        this.createBy = createBy;
        this.createTime = createTime;
        this.updateBy = updateBy;
        this.updateTime = updateTime;
        this.remark = remark;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(unid);
        dest.writeString(fUnid);
        dest.writeString(matingStyle);
        dest.writeString(cattleresumeId);
        dest.writeString(frozenSemenBatch);
        dest.writeString(matingDate);
        dest.writeString(isReturn);
        dest.writeString(backLoveDate);
        dest.writeString(dueDate);
        dest.writeString(pregnancy);
        dest.writeString(deptId);
        dest.writeString(uploadStatus);
        dest.writeString(searchValue);
        dest.writeString(createBy);
        dest.writeString(createTime);
        dest.writeString(updateBy);
        dest.writeString(updateTime);
        dest.writeString(remark);
    }

    @Override
    public int describeContents() {
        return 0;
    }

    public static final Creator<BreedingRecordDetailEntity> CREATOR = new Creator<BreedingRecordDetailEntity>() {
        @Override
        public BreedingRecordDetailEntity createFromParcel(Parcel in) {
            return new BreedingRecordDetailEntity(in);
        }

        @Override
        public BreedingRecordDetailEntity[] newArray(int size) {
            return new BreedingRecordDetailEntity[size];
        }
    };

    public String getUnid() {
        return unid;
    }

    public void setUnid(String unid) {
        this.unid = unid;
    }

    public String getfUnid() {
        return fUnid;
    }

    public void setfUnid(String fUnid) {
        this.fUnid = fUnid;
    }

    public String getMatingStyle() {
        return matingStyle;
    }

    public void setMatingStyle(String matingStyle) {
        this.matingStyle = matingStyle;
    }

    public String getCattleresumeId() {
        return cattleresumeId;
    }

    public void setCattleresumeId(String cattleresumeId) {
        this.cattleresumeId = cattleresumeId;
    }

    public String getFrozenSemenBatch() {
        return frozenSemenBatch;
    }

    public void setFrozenSemenBatch(String frozenSemenBatch) {
        this.frozenSemenBatch = frozenSemenBatch;
    }

    public String getMatingDate() {
        return matingDate;
    }

    public void setMatingDate(String matingDate) {
        this.matingDate = matingDate;
    }

    public String getIsReturn() {
        return isReturn;
    }

    public void setIsReturn(String isReturn) {
        this.isReturn = isReturn;
    }

    public String getBackLoveDate() {
        return backLoveDate;
    }

    public void setBackLoveDate(String backLoveDate) {
        this.backLoveDate = backLoveDate;
    }

    public String getDueDate() {
        return dueDate;
    }

    public void setDueDate(String dueDate) {
        this.dueDate = dueDate;
    }

    public String getPregnancy() {
        return pregnancy;
    }

    public void setPregnancy(String pregnancy) {
        this.pregnancy = pregnancy;
    }

    public String getDeptId() {
        return deptId;
    }

    public void setDeptId(String deptId) {
        this.deptId = deptId;
    }

    public String getUploadStatus() {
        return uploadStatus;
    }

    public void setUploadStatus(String uploadStatus) {
        this.uploadStatus = uploadStatus;
    }

    public String getSearchValue() {
        return searchValue;
    }

    public void setSearchValue(String searchValue) {
        this.searchValue = searchValue;
    }

    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    public String getCreateTime() {
        return createTime;
    }

    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    public String getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(String updateTime) {
        this.updateTime = updateTime;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    @Override
    public String toString() {
        return "BreedingRecordDetailEntity{" +
                "unid='" + unid + '\'' +
                ", fUnid='" + fUnid + '\'' +
                ", matingStyle='" + matingStyle + '\'' +
                ", cattleresumeId='" + cattleresumeId + '\'' +
                ", frozenSemenBatch='" + frozenSemenBatch + '\'' +
                ", matingDate='" + matingDate + '\'' +
                ", isReturn='" + isReturn + '\'' +
                ", backLoveDate='" + backLoveDate + '\'' +
                ", dueDate='" + dueDate + '\'' +
                ", pregnancy='" + pregnancy + '\'' +
                ", deptId='" + deptId + '\'' +
                ", uploadStatus='" + uploadStatus + '\'' +
                ", searchValue='" + searchValue + '\'' +
                ", createBy='" + createBy + '\'' +
                ", createTime='" + createTime + '\'' +
                ", updateBy='" + updateBy + '\'' +
                ", updateTime='" + updateTime + '\'' +
                ", remark='" + remark + '\'' +
                '}';
    }

    public String getFUnid() {
        return this.fUnid;
    }

    public void setFUnid(String fUnid) {
        this.fUnid = fUnid;
    }
}
