package com.phlx.anchorcollect.entity;

import android.os.Parcel;
import android.os.Parcelable;

import androidx.databinding.BaseObservable;

import org.greenrobot.greendao.annotation.Entity;
import org.greenrobot.greendao.annotation.Generated;
import org.greenrobot.greendao.annotation.Id;

/**
 * 免疫记录
 * 作者 : lei
 * 时间 : 2018/12/3 11 : 04
 */
@Entity
public class ImmuneEntity extends BaseObservable implements Parcelable {
    //主键
    private Long id;
    /**
     * 主键
     */
    @Id
    private String unid;

    /**
     * 登记号
     */
    private String registrationNo;
    /**
     * 圈舍号
     */
    private String circleNo;
    /**
     * 疫苗品种
     */
    private String vaccineName;
    /**
     * 疫苗批号
     */
    private String lotnumber;
    /**
     * 生产厂家
     */
    private String manufacturer;
    /**
     * 商品名
     */
    private String productName;
    /**
     * 规格
     */
    private String specifications;

    /**
     * 库存
     */
    private String remainingNumber;
    /**
     * 免疫方法（滴鼻，注射，口服，刺种，气雾）
     */
    private String immuneMethod;
    /**
     * 免疫剂量
     */
    private String immuneDosage;
    /**
     * 免疫日期
     */
    private String immuneDate;
    /**
     * 免疫人员
     */
    private String immunePerson;
    /**
     * 备注
     */
    private String note;
    /**
     * 更新状态
     */
    private String updateId;
    /**
     * 创建者
     */
    private String createBy;

    /**
     * 创建时间
     */
    private String createTime;

    /**
     * 更新者
     */
    private String updateBy;

    /**
     * 更新时间
     */
    private String updateTime;

    /**
     * 权限标识
     */
    private String permissions;

    /**
     * 从服务器接收，时间戳，终端需要上传给服务器，
     */
    private String inputTime;

    public ImmuneEntity() {
    }

    protected ImmuneEntity(Parcel in) {
        if (in.readByte() == 0) {
            id = null;
        } else {
            id = in.readLong();
        }
        unid = in.readString();
        registrationNo = in.readString();
        circleNo = in.readString();
        vaccineName = in.readString();
        lotnumber = in.readString();
        manufacturer = in.readString();
        productName = in.readString();
        specifications = in.readString();
        remainingNumber = in.readString();
        immuneMethod = in.readString();
        immuneDosage = in.readString();
        immuneDate = in.readString();
        immunePerson = in.readString();
        note = in.readString();
        updateId = in.readString();
        createBy = in.readString();
        createTime = in.readString();
        updateBy = in.readString();
        updateTime = in.readString();
        permissions = in.readString();
        inputTime = in.readString();
    }

    @Generated(hash = 986685803)
    public ImmuneEntity(Long id, String unid, String registrationNo, String circleNo,
            String vaccineName, String lotnumber, String manufacturer, String productName,
            String specifications, String remainingNumber, String immuneMethod,
            String immuneDosage, String immuneDate, String immunePerson, String note,
            String updateId, String createBy, String createTime, String updateBy,
            String updateTime, String permissions, String inputTime) {
        this.id = id;
        this.unid = unid;
        this.registrationNo = registrationNo;
        this.circleNo = circleNo;
        this.vaccineName = vaccineName;
        this.lotnumber = lotnumber;
        this.manufacturer = manufacturer;
        this.productName = productName;
        this.specifications = specifications;
        this.remainingNumber = remainingNumber;
        this.immuneMethod = immuneMethod;
        this.immuneDosage = immuneDosage;
        this.immuneDate = immuneDate;
        this.immunePerson = immunePerson;
        this.note = note;
        this.updateId = updateId;
        this.createBy = createBy;
        this.createTime = createTime;
        this.updateBy = updateBy;
        this.updateTime = updateTime;
        this.permissions = permissions;
        this.inputTime = inputTime;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        if (id == null) {
            dest.writeByte((byte) 0);
        } else {
            dest.writeByte((byte) 1);
            dest.writeLong(id);
        }
        dest.writeString(unid);
        dest.writeString(registrationNo);
        dest.writeString(circleNo);
        dest.writeString(vaccineName);
        dest.writeString(lotnumber);
        dest.writeString(manufacturer);
        dest.writeString(productName);
        dest.writeString(specifications);
        dest.writeString(remainingNumber);
        dest.writeString(immuneMethod);
        dest.writeString(immuneDosage);
        dest.writeString(immuneDate);
        dest.writeString(immunePerson);
        dest.writeString(note);
        dest.writeString(updateId);
        dest.writeString(createBy);
        dest.writeString(createTime);
        dest.writeString(updateBy);
        dest.writeString(updateTime);
        dest.writeString(permissions);
        dest.writeString(inputTime);
    }

    @Override
    public int describeContents() {
        return 0;
    }

    public static final Creator<ImmuneEntity> CREATOR = new Creator<ImmuneEntity>() {
        @Override
        public ImmuneEntity createFromParcel(Parcel in) {
            return new ImmuneEntity(in);
        }

        @Override
        public ImmuneEntity[] newArray(int size) {
            return new ImmuneEntity[size];
        }
    };

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getUnid() {
        return unid;
    }

    public void setUnid(String unid) {
        this.unid = unid;
    }

    public String getRegistrationNo() {
        return registrationNo;
    }

    public void setRegistrationNo(String registrationNo) {
        this.registrationNo = registrationNo;
    }

    public String getCircleNo() {
        return circleNo;
    }

    public void setCircleNo(String circleNo) {
        this.circleNo = circleNo;
    }

    public String getVaccineName() {
        return vaccineName;
    }

    public void setVaccineName(String vaccineName) {
        this.vaccineName = vaccineName;
    }

    public String getLotnumber() {
        return lotnumber;
    }

    public void setLotnumber(String lotnumber) {
        this.lotnumber = lotnumber;
    }

    public String getManufacturer() {
        return manufacturer;
    }

    public void setManufacturer(String manufacturer) {
        this.manufacturer = manufacturer;
    }

    public String getProductName() {
        return productName;
    }

    public void setProductName(String productName) {
        this.productName = productName;
    }

    public String getSpecifications() {
        return specifications;
    }

    public void setSpecifications(String specifications) {
        this.specifications = specifications;
    }

    public String getRemainingNumber() {
        return remainingNumber;
    }

    public void setRemainingNumber(String remainingNumber) {
        this.remainingNumber = remainingNumber;
    }

    public String getImmuneMethod() {
        return immuneMethod;
    }

    public void setImmuneMethod(String immuneMethod) {
        this.immuneMethod = immuneMethod;
    }

    public String getImmuneDosage() {
        return immuneDosage;
    }

    public void setImmuneDosage(String immuneDosage) {
        this.immuneDosage = immuneDosage;
    }

    public String getImmuneDate() {
        return immuneDate;
    }

    public void setImmuneDate(String immuneDate) {
        this.immuneDate = immuneDate;
    }

    public String getImmunePerson() {
        return immunePerson;
    }

    public void setImmunePerson(String immunePerson) {
        this.immunePerson = immunePerson;
    }

    public String getNote() {
        return note;
    }

    public void setNote(String note) {
        this.note = note;
    }

    public String getUpdateId() {
        return updateId;
    }

    public void setUpdateId(String updateId) {
        this.updateId = updateId;
    }

    public String getCreateBy() {
        return createBy;
    }

    public void setCreateBy(String createBy) {
        this.createBy = createBy;
    }

    public String getCreateTime() {
        return createTime;
    }

    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    public String getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(String updateBy) {
        this.updateBy = updateBy;
    }

    public String getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(String updateTime) {
        this.updateTime = updateTime;
    }

    public String getPermissions() {
        return permissions;
    }

    public void setPermissions(String permissions) {
        this.permissions = permissions;
    }

    public String getInputTime() {
        return inputTime;
    }

    public void setInputTime(String inputTime) {
        this.inputTime = inputTime;
    }

    @Override
    public String toString() {
        return "ImmuneEntity{" +
                "id=" + id +
                ", unid='" + unid + '\'' +
                ", registrationNo='" + registrationNo + '\'' +
                ", circleNo='" + circleNo + '\'' +
                ", vaccineName='" + vaccineName + '\'' +
                ", lotnumber='" + lotnumber + '\'' +
                ", manufacturer='" + manufacturer + '\'' +
                ", productName='" + productName + '\'' +
                ", specifications='" + specifications + '\'' +
                ", remainingNumber='" + remainingNumber + '\'' +
                ", immuneMethod='" + immuneMethod + '\'' +
                ", immuneDosage='" + immuneDosage + '\'' +
                ", immuneDate='" + immuneDate + '\'' +
                ", immunePerson='" + immunePerson + '\'' +
                ", note='" + note + '\'' +
                ", updateId='" + updateId + '\'' +
                ", createBy='" + createBy + '\'' +
                ", createTime='" + createTime + '\'' +
                ", updateBy='" + updateBy + '\'' +
                ", updateTime='" + updateTime + '\'' +
                ", permissions='" + permissions + '\'' +
                ", inputTime='" + inputTime + '\'' +
                '}';
    }
}
