package com.phlx.anchorcollect.entity;

import android.os.Parcel;
import android.os.Parcelable;

import androidx.databinding.BaseObservable;

import org.greenrobot.greendao.annotation.Entity;
import org.greenrobot.greendao.annotation.Id;
import org.greenrobot.greendao.annotation.Generated;

/**
 * 称重管理类
 */
@Entity
public class WeightingEntity extends BaseObservable implements Parcelable {

    private long id;

    /**
     * unid主键
     */
    @Id(autoincrement = false)
    private String unid;

    /**
     * 登记号
     */
    private String RegistrationNo;

    /**
     * 称重名称
     */
    private String weightName;

    /**
     * 重量
     */
    private String weight;

    /**
     * 称重日期
     */
    private String weightingDate;

    /**
     * 负责人
     */
    private String principalName;

    /**
     * 负责人id
     */
    private String principalId;

    /**
     * 圈号
     */
    private String weightCount;

    /**
     * 圈号
     */
    private String circleNo;

    public WeightingEntity() {
    }

    protected WeightingEntity(Parcel in) {
        id = in.readLong();
        unid = in.readString();
        RegistrationNo = in.readString();
        weightName = in.readString();
        weight = in.readString();
        weightingDate = in.readString();
        principalName = in.readString();
        principalId = in.readString();
        weightCount = in.readString();
        circleNo = in.readString();
    }

    @Generated(hash = 1553460234)
    public WeightingEntity(long id, String unid, String RegistrationNo, String weightName,
            String weight, String weightingDate, String principalName, String principalId,
            String weightCount, String circleNo) {
        this.id = id;
        this.unid = unid;
        this.RegistrationNo = RegistrationNo;
        this.weightName = weightName;
        this.weight = weight;
        this.weightingDate = weightingDate;
        this.principalName = principalName;
        this.principalId = principalId;
        this.weightCount = weightCount;
        this.circleNo = circleNo;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeLong(id);
        dest.writeString(unid);
        dest.writeString(RegistrationNo);
        dest.writeString(weightName);
        dest.writeString(weight);
        dest.writeString(weightingDate);
        dest.writeString(principalName);
        dest.writeString(principalId);
        dest.writeString(weightCount);
        dest.writeString(circleNo);
    }

    @Override
    public int describeContents() {
        return 0;
    }

    public static final Creator<WeightingEntity> CREATOR = new Creator<WeightingEntity>() {
        @Override
        public WeightingEntity createFromParcel(Parcel in) {
            return new WeightingEntity(in);
        }

        @Override
        public WeightingEntity[] newArray(int size) {
            return new WeightingEntity[size];
        }
    };

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getUnid() {
        return unid;
    }

    public void setUnid(String unid) {
        this.unid = unid;
    }

    public String getRegistrationNo() {
        return RegistrationNo;
    }

    public void setRegistrationNo(String registrationNo) {
        RegistrationNo = registrationNo;
    }

    public String getWeightName() {
        return weightName;
    }

    public void setWeightName(String weightName) {
        this.weightName = weightName;
    }

    public String getWeight() {
        return weight;
    }

    public void setWeight(String weight) {
        this.weight = weight;
    }

    public String getWeightingDate() {
        return weightingDate;
    }

    public void setWeightingDate(String weightingDate) {
        this.weightingDate = weightingDate;
    }

    public String getPrincipalName() {
        return principalName;
    }

    public void setPrincipalName(String principalName) {
        this.principalName = principalName;
    }

    public String getPrincipalId() {
        return principalId;
    }

    public void setPrincipalId(String principalId) {
        this.principalId = principalId;
    }

    public String getWeightCount() {
        return weightCount;
    }

    public void setWeightCount(String weightCount) {
        this.weightCount = weightCount;
    }

    public String getCircleNo() {
        return circleNo;
    }

    public void setCircleNo(String circleNo) {
        this.circleNo = circleNo;
    }

    @Override
    public String toString() {
        return "WeightingEntity{" +
                "id=" + id +
                ", unid='" + unid + '\'' +
                ", RegistrationNo='" + RegistrationNo + '\'' +
                ", weightName='" + weightName + '\'' +
                ", weight='" + weight + '\'' +
                ", weightingDate='" + weightingDate + '\'' +
                ", principalName='" + principalName + '\'' +
                ", principalId='" + principalId + '\'' +
                ", weightCount='" + weightCount + '\'' +
                ", circleNo='" + circleNo + '\'' +
                '}';
    }
}
